<?php
class JsTreeWidget extends CWidget
{
    public $assetLocation = 'application.extensions.jstree';
    public $server = '';
    public $plugins = array();
    public $themes = array();
    public $allplugins =  array("themes","json_data","ui","crrm","cookies","dnd","search","types","hotkeys","contextmenu");
    
    public function getTheme($name){
        switch($name){                                
             case "theme":
                 if ( isset($this->themes[$name]) ) return '"'.$this->themes[$name].'"';
                 return '"default"';
             default:
                 if ( isset($this->themes[$name]) ) {
                     if ($this->themes[$name] == false) return 0;
                 } 
                 return true;       
        }    
    }
    public function getPlugin($name){
        if ( isset($this->plugins[$name]) ) return $this->plugins[$name];
        return true;
    }
    public function getPlugins(){
          $plugins = "";
          foreach($this->allplugins as $plugin){ 
              if ($this->getPlugin($plugin) ) $plugins.='"'.$plugin.'",';
          }
          return $plugins;
    }
    public function init(){
       $assetsFolder=Yii::app()->assetManager->publish(Yii::getPathOfAlias($this->assetLocation));
       Yii::app()->clientScript->registerScriptFile($assetsFolder.'/jquery.jstree.js');
       Yii::app()->clientScript->registerScriptFile($assetsFolder.'/_lib/jquery.cookie.js');
       Yii::app()->clientScript->registerScriptFile($assetsFolder.'/_lib/jquery.hotkeys.js');
       
?>


    <div id="container">
    <div id="description">
    <div id="mmenu" style="height:30px; overflow:auto;">
        
    <?PHP
    if ($this->getPlugin("search")) { ?>
    <input type="button" id="clear_search" value="Clear" style="display:block; float:right;"/>
    <input type="button" id="search" value="Search" style="display:block; float:right;"/>
    <input type="text" id="text" value="" style="display:block; float:right;" />
    <?PHP }
    ?>


    </div>
    All: <a href='javascript:var test = $("#demo").jstree("open_all");'>Open</a> <a href='javascript:var test =$("#demo").jstree("close_all");'>Close</a> 
    <!-- the tree container (notice NOT an UL node) -->
    <div id="demo" class="demo" style="padding-bottom:60px;"></div>

    <!-- JavaScript neccessary for the tree -->
    <script type="text/javascript">
    $(function () {
    $("#demo")
            .jstree({ 
                 "themes" : {
                            "theme" :  <?PHP echo $this->getTheme("theme"); ?> ,
                            "dots" : <?PHP echo $this->getTheme("dots"); ?>,
                            "icons" : <?PHP echo $this->getTheme("icons"); ?>

                    },
                    // List of active plugins "themes","json_data","ui","crrm","cookies","dnd","search","types","hotkeys","contextmenu" 
                    "plugins" : [ 
                        <?PHP echo $this->getPlugins(); ?>        
                    ],
                    // I usually configure the plugin that handles the data first
                    // This example uses JSON as it is most common
                    "json_data" : { 
                            // This tree is ajax enabled - as this is most common, and maybe a bit more complex
                            // All the options are almost the same as jQuery's AJAX (read the docs)
                            "ajax" : {
                                    // the URL to fetch the data
                                    "url" : "<?PHP echo $this->server?>",
                                    // the `data` function is executed in the instance's scope
                                    // the parameter is the node being loaded 
                                    // (may be -1, 0, or undefined when loading the root nodes)
                                    "data" : function (n) {  
                                            // the result is fed to the AJAX request `data` option
                                            return { 								
                                                    "operation" : "get_children", 
                                                    "id" : n.attr ? n.attr("id").replace("node_","") : 1 
                                            }; 
                                    }
                            }
                    },
                    // Configuring the search plugin
                    "search" : {
                            // As this has been a common question - async search
                            // Same as above - the `ajax` config option is actually jQuery's AJAX object
                            "ajax" : {
                                    "url" : "<?PHP echo $this->server?>",
                                    // You get the search string as a parameter
                                    "data" : function (str) {
                                            return { 
                                                    "operation" : "search", 
                                                    "search_str" : str 
                                            }; 
                                    }
                            }
                    },
                    // Using types - most of the time this is an overkill
                    // read the docs carefully to decide whether you need types
                    "types" : {
                            // I set both options to -2, as I do not need depth and children count checking
                            // Those two checks may slow jstree a lot, so use only when needed
                            "max_depth" : -2,
                            "max_children" : -2,
                            // I want only `drive` nodes to be root nodes 
                            // This will prevent moving or creating any other type as a root node
                            "valid_children" : [ "drive" ],
                            "types" : {
                                    // The default type
                                    "default" : {
                                            // I want this type to have no children (so only leaf nodes)
                                            // In my case - those are files
                                            "valid_children" : "none",
                                            // If we specify an icon for the default type it WILL OVERRIDE the theme icons
                                            "icon" : {
                                                    "image" : "./images/jstree/file.png"
                                            }
                                    },
                                    // The `folder` type
                                    "folder" : {
                                            // can have files and other folders inside of it, but NOT `drive` nodes
                                            "valid_children" : [ "default", "folder" ],
                                            "icon" : {
                                                    "image" : "./images/jstree/folder.png"
                                            }
                                    },
                                    // The `drive` nodes 
                                    "drive" : {
                                            // can have files and folders inside, but NOT other `drive` nodes
                                            "valid_children" : [ "default", "folder" ],
                                            "icon" : {
                                                    "image" : "./images/jstree/root.png"
                                            },
                                            // those prevent the functions with the same name to be used on `drive` nodes
                                            // internally the `before` event is used
                                            "start_drag" : false,
                                            "move_node" : false,
                                            "delete_node" : false,
                                            "remove" : false
                                    }
                            }
                    },
                    // UI & core - the nodes to initially select and open will be overwritten by the cookie plugin

                    // the UI plugin - it handles selecting/deselecting/hovering nodes
                    "ui" : {
                            // this makes the node with ID node_4 selected onload
                            "initially_select" : [ "node_4" ]
                    },
                    // the core plugin - not many options here
                    "core" : { 
                            // just open those two nodes up
                            // as this is an AJAX enabled tree, both will be downloaded from the server
                            "initially_open" : [ "node_2" , "node_3" ] 
                    }
            })
            .bind("remove.jstree", function (e, data) { 
                    data.rslt.obj.each(function () {
                            $.ajax({
                                    async : false,
                                    type: 'POST',
                                    url: "<?PHP echo $this->server?>",
                                    data : { 
                                            "operation" : "remove_node", 
                                            "id" : this.id.replace("node_",""),
                                            "onlyone" : true
                                    }, 
                                    success : function (r) {
                                            if(!r.status) {
                                                    data.inst.refresh();
                                            }
                                            else{
                                                    data.inst.refresh();
                                            }
                                    }
                            });
                    });
            })
            .bind("removeAll.jstree", function (e, data) { 
                    data.rslt.obj.each(function () {
                            $.ajax({
                                    async : false,
                                    type: 'POST',
                                    url: "<?PHP echo $this->server?>",
                                    data : { 
                                            "operation" : "remove_node", 
                                            "id" : this.id.replace("node_","")
                                    }, 
                                    success : function (r) {
                                            if(!r.status) {
                                                    data.inst.refresh();
                                            } else{
                                                    data.inst.refresh();
                                            }
                                    }
                            });
                    });
            })
            .bind("create.jstree", function (e, data) {
                    $.post(
                            "<?PHP echo $this->server?>", 
                            { 
                                    "operation" : "create_node", 
                                    "id" : data.rslt.parent.attr("id").replace("node_",""), 
                                    "position" : data.rslt.position,
                                    "title" : data.rslt.name,
                                    "type" : data.rslt.obj.attr("rel")
                            }, 
                            function (r) { 
                                    if(r.status) {
                                            $(data.rslt.obj).attr("id", "node_" + r.id);
                                    }
                                    data.inst.refresh();
                            }
                    );
            })
            .bind("rename.jstree", function (e, data) {
                    $.post(
                            "<?PHP echo $this->server?>", 
                            { 
                                    "operation" : "rename_node", 
                                    "id" : data.rslt.obj.attr("id").replace("node_",""),
                                    "title" : data.rslt.new_name
                            }, 
                            function (r) {
                                    if(!r.status) {
                                            $.jstree.rollback(data.rlbk);
                                    }
                    //		else{
            //				data.inst.refresh();
    //				}
                                    data.inst.refresh();
                            }
                    );
            })
            .bind("move_node.jstree", function (e, data) {
                    data.rslt.o.each(function (i) {
                            $.ajax({
                                    async : false,
                                    type: 'POST',
                                    url: "<?PHP echo $this->server?>",
                                    data : { 
                                            "operation" : "move_node", 
                                            "id" : $(this).attr("id").replace("node_",""), 
                                            "ref" : data.rslt.cr === -1 ? 1 : data.rslt.np.attr("id").replace("node_",""), 
                                            "position" : data.rslt.o.index() + i,
                                            "title" : data.rslt.name,
                                            "copy" : data.rslt.cy ? 1 : 0
                                    },
                                    success : function (r) {
                                    //does this get executed?
                                            if(!r.status) {
                                                    $.jstree.rollback(data.rlbk);
                                            }
                                            else {
                                                    data.inst.refresh();
                                                    $(data.rslt.oc).attr("id", "node_" + r.id);
                                                    if(data.rslt.cy && $(data.rslt.oc).children("UL").length) {
                                                            data.inst.refresh(data.inst._get_parent(data.rslt.oc));
                                                    }

                                            }

                                            $("#demo").jstree("refresh");
                                            $("#analyze").click();
                                    }
                            });
                    });
            });

    });
    </script>
    <script type="text/javascript">
    // Code for the menu buttons
    $(function () { 
            $("#mmenu input").click(function () {
                    switch(this.id) {
                            case "search":
                                    $("#demo").jstree("search", document.getElementById("text").value);
                                    break;
                            default:
                                    $("#demo").jstree(this.id);
                                    break;
                    }
            });
    });
    </script>
    </div>
    </div>
<?PHP       
    } //end init
} //end class
?>