<?php 
class _tree_struct {
	// Structure table and fields
	protected $table	= "";
	protected $sitestable	= "";
	protected $fields	= array(
			"id"		=> false,
			"parent_id"	=> false,
			"position"	=> false,
			"left"		=> false,
			"right"		=> false,
			"level"		=> false
		);

	// Constructor
	function __construct($table = "tbl_sites_tree", $fields = array(), $sitestable = "tbl_sites") {
	
//	$fh = fopen(time()."contstruct".rand().".txt", 'w') or die("can't open file");
//	fwrite($fh, print_r($fields, true));
//	fclose($fh);
	
		$this->table = $table;
		$this->sitestable = $sitestable;
		if(!count($fields)) {
			foreach($this->fields as $k => &$v) {
					switch($k) {
						case "parent_id": 
							$this->fields[$k] = "parentId_n";
							break;
						case "position": 
							$this->fields[$k] = "position_n";
							break;
						case "left": 
							$this->fields[$k] = "left_n";
							break;
						case "right": 
							$this->fields[$k] = "right_n";
							break;
						case "level": 
							$this->fields[$k] = "level_n";
							break;
						case "type": 
							$this->fields[$k] = "type_c";
							break;
						default: 
							$v = $k; 
							break;
					}
			
				
			}
		}
		else {
			foreach($fields as $key => $field) {
				switch($key) {
					case "id":
					case "parent_id":
						$this->fields[$key] = "parentId_n";
						break;
					case "position":
                                                $this->fields[$key] = "position_n";
						break;
					case "left":
                       				$this->fields[$key] = "left_n";
						break;
					case "right":
                                                $this->fields[$key] = "right_n";
						break;
					case "level":
						$this->fields[$key] = "level_n";
						break;
					case "siteId_n":
						$this->fields[$key] = $field;
						break;
				}
			}
		}
		// Database
		$this->db = new _database;
	}

	function _get_node($id, $actual_id = -1) {
	
		if ( strrpos($id, '-') !== false ){
			$ids = explode("-", $id);
			$queryid = $ids[1];
		} else $queryid = $id;
	
		$sql = "SELECT  concat( concat(`".$this->table."`.`id`, '-'), `".$this->table."`.siteId_n)as id, " . 
		"`".$this->fields["parent_id"]."`, " . 
		"`".$this->fields["position"]."`, " . 
		"`".$this->fields["left"]."`, " . 
		"`".$this->fields["right"]."`, " . 
		"`".$this->fields["level"]."`, 
		`name_c` as title, 
		`".$this->fields["type"]."`,
		`".$this->table."`.`siteId_n` 
				FROM `".$this->table."` LEFT JOIN `".$this->sitestable."` 
				ON `".$this->table."`.`id` = `".$this->sitestable."`.siteId_n
				 WHERE `".$this->table."`.siteId_n = '$queryid'";
		if ($actual_id != -1)
			$sql .= " and `".$this->table."`.`id` = ".$actual_id;
	

//		$fh = fopen(time()."getNode".rand().".txt", 'w') or die("can't open file");
//		fwrite($fh, $sql);
//		fclose($fh);

	
	
		//$this->db->query("SELECT `".implode("` , `", $this->fields)."` FROM `".$this->table."` WHERE `".$this->fields["id"]."` = ".(int) $id);
		$this->db->query($sql);
		$this->db->nextr();
		return $this->db->nf() === 0 ? false : $this->db->get_row("assoc");
	}
	function _get_children($id, $recursive = false, $actual_id = -1) {
	
	
	//		$myFile ="getchildrenID.txt";
	//		$fh = fopen($myFile, 'w') or die("can't open file");
	//		fwrite($fh, $id);
	//		fclose($fh);
			
		if ( strrpos($id, '-') !== false ){
		
		//	$myFile ="FOUND.txt";
		//	$fh = fopen($myFile, 'w') or die("can't open file");
			
			$ids = explode("-", $id);
			$queryid = $ids[1];
		} else $queryid = $id;
	
	
	
	//	$myFile = time()."_getChildren0_".rand().".txt";
	//	$fh = fopen($myFile, 'w') or die("can't open file");
	
		$children = array();
		if($recursive) {
			$node = $this->_get_node($id);
			
			$sql = "SELECT `".implode("` , `", $this->fields)."` FROM `".$this->table."` WHERE `".$this->fields["left"]."` >= ".(int) $node[$this->fields["left"]]." AND `".$this->fields["right"]."` <= ".(int) $node[$this->fields["right"]]." ORDER BY `".$this->fields["left"]."`       ASC";
			$sql = str_replace("`title` ,", "", $sql);
	//	$myFile = time()."_getChildren1_".rand().".txt";
	//	$fh = fopen($myFile, 'w') or die("can't open file");
	//fwrite($fh, $sql);
	//	fclose($fh);

			
		//	$this->db->query("SELECT `".implode("` , `", $this->fields)."` FROM `".$this->table."` WHERE `".$this->fields["left"]."` >= ".(int) $node[$this->fields["left"]]." AND `".$this->fields["right"]."` <= ".(int) $node[$this->fields["right"]]." ORDER BY `".$this->fields["left"]."` ASC");
			$this->db->query($sql);
			
		}
		else {
		

		
		$sql = "SELECT concat( concat(`".$this->table."`.`id`, '-'), `".$this->table."`.siteId_n)as id ," . 
		"`".$this->fields["parent_id"]."`, " . 
		"`".$this->fields["position"]."`, " . 
		"`".$this->fields["left"]."`, " . 
		"`".$this->fields["right"]."`, " . 
		"`".$this->fields["level"]."`,
		`name_c` as title ,
		`".$this->fields["type"]."`
				FROM `".$this->table."` LEFT JOIN `".$this->sitestable."` 
				ON `".$this->table."`.siteId_n = `".$this->sitestable."`.siteId_n
				WHERE `".$this->fields["parent_id"]."` = '$queryid'";
		
		if ($actual_id != -1)
			$sql .= " and `".$this->table."`.`id` = ".$actual_id;
		
		$sql .=		" ORDER BY `".$this->fields["position"]."` ASC";

	//	$myFile = time()."_getChildren2_".rand().".txt";
//		$fh = fopen($myFile, 'w') or die("can't open file");//
//		fwrite($fh, $sql);
//		fclose($fh);

				
				
		//	$this->db->query("SELECT `".implode("` , `", $this->fields)."` FROM `".$this->table."` WHERE `".$this->fields["parent_id"]."` = ".(int) $id." ORDER BY `".$this->fields["position"]."` ASC");
			$this->db->query($sql);
		
		}
		while($this->db->nextr()) $children[$this->db->f($this->fields["id"])] = $this->db->get_row("assoc");
		return $children;
	}
	function _get_path($id) {
	
	
		//$myFile = "getpath".rand().".txt";
		//fh = fopen($myFile, 'w');
	
		$node = $this->_get_node($id);
		$path = array();
		if(!$node === false) return false;
		$this->db->query("SELECT `".implode("` , `", $this->fields)."` FROM `".$this->table."` WHERE `".$this->fields["left"]."` <= ".(int) $node[$this->fields["left"]]." AND `".$this->fields["right"]."` >= ".(int) $node[$this->fields["right"]]);
		while($this->db->nextr()) $path[$this->db->f($this->fields["id"])] = $this->db->get_row("assoc");
		return $path;
	}

	function _create($parent, $position, $siteId_n) {

	
	
	//$fh = fopen(time()."create".rand().".txt", 'w') or die("can't open file");
	
		return $this->_move(0, $parent, $position, '', $siteId_n);
	}
	function _remove($id, $actual_id = -1) {
		
	//	$myFile = "__remove".rand().".txt";
	//	$fh = fopen($myFile, 'w');
	//	fwrite($fh, $id." ".$actual_id);
	//	fclose($fh);
		
		
		
		if($id === 1) { return false; }
		
		
		if ($actual_id == -1) $data = $this->_get_node($id);
		else 				  $data = $this->_get_node($id, $actual_id);
		
		//$data = $this->_get_node($id);
		$lft = (int)$data[$this->fields["left"]];
		$rgt = (int)$data[$this->fields["right"]];
		$dif = $rgt - $lft + 1;

		// deleting node and its children
		$this->db->query("" . 
			"DELETE FROM `".$this->table."` " . 
		//	"WHERE `".$this->fields["left"]."` >= ".$lft." AND `".$this->fields["right"]."` <= ".$rgt
			" WHERE id = ".$actual_id
		);
		
		//delete actual id from groupsites if no more exist in the tree
		
			$s = "SELECT * from `".$this->table."` where siteId_n =".$id;
			$this->db->query($s);
			$this->db->nextr();
			if ($this->db->nf() === 0 ) {
				$s = "Delete from `".$this->sitestable."` where siteId_n =".$id;
				$this->db->query($s);
			
			
			}
		
		// shift left indexes of nodes right of the node
		$this->db->query("".
			"UPDATE `".$this->table."` " . 
				"SET `".$this->fields["left"]."` = `".$this->fields["left"]."` - ".$dif." " . 
			"WHERE `".$this->fields["left"]."` > ".$rgt
		);
		// shift right indexes of nodes right of the node and the node's parents
		$this->db->query("" . 
			"UPDATE `".$this->table."` " . 
				"SET `".$this->fields["right"]."` = `".$this->fields["right"]."` - ".$dif." " . 
			"WHERE `".$this->fields["right"]."` > ".$lft
		);

		$pid = (int)$data[$this->fields["parent_id"]];
		$pos = (int)$data[$this->fields["position"]];

		// Update position of siblings below the deleted node
		$this->db->query("" . 
			"UPDATE `".$this->table."` " . 
				"SET `".$this->fields["position"]."` = `".$this->fields["position"]."` - 1 " . 
			"WHERE `".$this->fields["parent_id"]."` = ".$pid." AND `".$this->fields["position"]."` > ".$pos
		);
		return true;
	}
	function _move($id, $ref_id, $position = 0, $is_copy = false, $siteId_n = -1) {
	
		$queryid = $ref_id;

		if ( strrpos($ref_id, '-') !== false ){
			$ref_ids = explode("-", $ref_id);
			$queryid = $ref_ids[1];
		}
		//$ref_id =$queryid;
	
		//$myFile = "move".rand().".txt";
		//$fh = fopen($myFile, 'w');
		//fwrite($fh, $queryid." id=".$id." refid=".$ref_id);
	
	
		if($ref_id === 0 || $id === 1) { return false; }
		$sql		= array();						// Queries executed at the end
		
		$node		= $this->_get_node($id, $siteId_n);		// Node data
		$nchildren	= $this->_get_children($id, $siteId_n);	// Node children   //prob should add $siteId_n
		
		$ref_node	= $this->_get_node($ref_id);	// Ref node data
		$rchildren	= $this->_get_children($ref_id);// Ref node children

		
		//fwrite($fh, print_r($node, true) );
		//fclose($fh);
		
		$ndif = 2;
		$node_ids = array(-1);
		if($node !== false) {
			$node_ids = array_keys($this->_get_children($id, true));
			// TODO: should be !$is_copy && , but if copied to self - screws some right indexes
			if(in_array($ref_id, $node_ids)) return false;
			$ndif = $node[$this->fields["right"]] - $node[$this->fields["left"]] + 1;
		}
		if($position >= count($rchildren)) {
			$position = count($rchildren);
		}

		// Not creating or copying - old parent is cleaned
		if($node !== false && $is_copy == false) {

		$sql[] = "" . 
				"UPDATE `".$this->table."` " . 
					"SET `".$this->fields["position"]."` = `".$this->fields["position"]."` - 1 " . 
				"WHERE " . 
					"`".$this->fields["parent_id"]."` = ".$node[$this->fields["parent_id"]]." AND " . 

					"`".$this->fields["position"]."` > ".$node[$this->fields["position"]];

		
		$sql[] = "" . 
				"UPDATE `".$this->table."` " . 
					"SET `".$this->fields["left"]."` = `".$this->fields["left"]."` - ".$ndif." " . 
				"WHERE `".$this->fields["left"]."` > ".$node[$this->fields["right"]];
			$sql[] = "" . 
				"UPDATE `".$this->table."` " . 
					"SET `".$this->fields["right"]."` = `".$this->fields["right"]."` - ".$ndif." " . 
				"WHERE " . 
					"`".$this->fields["right"]."` > ".$node[$this->fields["left"]]." AND " . 
					"`".$this->fields["id"]."` NOT IN (".implode(",", $node_ids).") ";
		}
		// Preparing new parent
		$sql[] = "" . 
			"UPDATE `".$this->table."` " . 
				"SET `".$this->fields["position"]."` = `".$this->fields["position"]."` + 1 " . 
			"WHERE " . 
			//	"`".$this->fields["parent_id"]."` = ".$ref_id." AND " . 
			"`".$this->fields["parent_id"]."` = ".$queryid." AND " . 
				"`".$this->fields["position"]."` >= ".$position." " . 
				( $is_copy ? "" : " AND `".$this->fields["id"]."` NOT IN (".implode(",", $node_ids).") ");

		$ref_ind = $ref_id === 0 ? (int)$rchildren[count($rchildren) - 1][$this->fields["right"]] + 1 : (int)$ref_node[$this->fields["right"]];
		$ref_ind = max($ref_ind, 1);

		$self = ($node !== false && !$is_copy && (int)$node[$this->fields["parent_id"]] == $ref_id && $position > $node[$this->fields["position"]]) ? 1 : 0;
		foreach($rchildren as $k => $v) {
			if($v[$this->fields["position"]] - $self == $position) {
				$ref_ind = (int)$v[$this->fields["left"]];
				break;
			}
		}
		if($node !== false && !$is_copy && $node[$this->fields["left"]] < $ref_ind) {
			$ref_ind -= $ndif;
		}

		$sql[] = "" . 
			"UPDATE `".$this->table."` " . 
				"SET `".$this->fields["left"]."` = `".$this->fields["left"]."` + ".$ndif." " . 
			"WHERE " . 
				"`".$this->fields["left"]."` >= ".$ref_ind." " . 
				( $is_copy ? "" : " AND `".$this->fields["id"]."` NOT IN (".implode(",", $node_ids).") ");
		$sql[] = "" . 
			"UPDATE `".$this->table."` " . 
				"SET `".$this->fields["right"]."` = `".$this->fields["right"]."` + ".$ndif." " . 
			"WHERE " . 
				"`".$this->fields["right"]."` >= ".$ref_ind." " . 
				( $is_copy ? "" : " AND `".$this->fields["id"]."` NOT IN (".implode(",", $node_ids).") ");

		$ldif = $ref_id == 0 ? 0 : $ref_node[$this->fields["level"]] + 1;
		$idif = $ref_ind;
		if($node !== false) {
			$ldif = $node[$this->fields["level"]] - ($ref_node[$this->fields["level"]] + 1);
			$idif = $node[$this->fields["left"]] - $ref_ind;
			if($is_copy) {
				$sql[] = "" . 
					"INSERT INTO `".$this->table."` (" . 
						"`".$this->fields["parent_id"]."`, " . 
						"`".$this->fields["position"]."`, " . 
						"`".$this->fields["left"]."`, " . 
						"`".$this->fields["right"]."`, " . 
						"`".$this->fields["level"]."`" . 
					") " . 
						"SELECT " . 
							"".$ref_id.", " . 
							"`".$this->fields["position"]."`, " . 
							"`".$this->fields["left"]."` - (".($idif + ($node[$this->fields["left"]] >= $ref_ind ? $ndif : 0))."), " . 
							"`".$this->fields["right"]."` - (".($idif + ($node[$this->fields["left"]] >= $ref_ind ? $ndif : 0))."), " . 
							"`".$this->fields["level"]."` - (".$ldif.") " . 
						"FROM `".$this->table."` " . 
						"WHERE " . 
							"`".$this->fields["id"]."` IN (".implode(",", $node_ids).") " . 
						"ORDER BY `".$this->fields["level"]."` ASC";
			}
			else {
				
				$where = ($siteId_n != -1) ? "`id` = ".$siteId_n : "`siteId_n` = ".$id;
			
			
				$sql[] = "" . 
					"UPDATE `".$this->table."` SET " . 
						"`".$this->fields["parent_id"]."` = ".$ref_id.", " . 
				//		"`groupsites_parent` = ".$ref_id.", " . 
						"`".$this->fields["position"]."` = ".$position." " . 
					"WHERE " . 
						$where;   //was $id  
						
					//	"`".$this->fields["id"]."` = ".$id;  //here
				$sql[] = "" . 
					"UPDATE `".$this->table."` SET " . 
						"`".$this->fields["left"]."` = `".$this->fields["left"]."` - (".$idif."), " . 
						"`".$this->fields["right"]."` = `".$this->fields["right"]."` - (".$idif."), " . 
						"`".$this->fields["level"]."` = `".$this->fields["level"]."` - (".$ldif.") " . 
					"WHERE " . 
						"`".$this->fields["id"]."` IN (".implode(",", $node_ids).") ";
			}
		}
		else {
		
			///john added this
				$sql[] = "UPDATE `".$this->table."` SET `".$this->fields["right"]."`=`".$this->fields["right"]."`+1 WHERE `siteId_n`=$queryid; ";
		
			$sql[] = "" . 
				"INSERT INTO `".$this->table."` (" . 
					"`".$this->fields["parent_id"]."`, " . 
					"`".$this->fields["position"]."`, " . 
					"`".$this->fields["left"]."`, " . 
					"`".$this->fields["right"]."`, " . 
					"`siteId_n`, " . 
			//		"`groupsites_parent`, " . 
					"`".$this->fields["level"]."` " . 
					") " . 
				"VALUES (" . 
					$queryid.", " .
					$position.", " . 
					$idif.", " . 
					($idif + 1).", " . 
					$siteId_n.", " . 
			//		$queryid.", " . 
					$ldif. 
				")";
			
		
		}
		
		
				
			////John added this to fix the children of node when parent lost a child, add ot at the end
	//	if ($id != $node[$this->fields["parent_id"]]) {
	//			$sql[] = "Update tree set `position` = `position` - 1 where groupsites_parent = ".$node[$this->fields["parent_id"]]. 
	//		" and position > ". $node[$this->fields["position"]];	
	//		
	//	}
		
		

//$myFile = "testFile".rand().".txt";
//$fh = fopen($myFile, 'w') or die("can't open file");
//fwrite($fh, print_r($sql, true) );
//fclose($fh);

	
		
		foreach($sql as $q) { $this->db->query($q); }
		$ind = $this->db->insert_id();
		if($is_copy) $this->_fix_copy($ind, $position);
		return $node === false || $is_copy ? $ind : true;
	}
	function _fix_copy($id, $position) {
	
//	$myFile = "fixcopy".rand().".txt";
//$fh = fopen($myFile, 'w');
//fwrite($fh,$id." ". $position );
//fclose($fh);
	
		$node = $this->_get_node($id);
		$children = $this->_get_children($id, true);

		$map = array();
		for($i = $node[$this->fields["left"]] + 1; $i < $node[$this->fields["right"]]; $i++) {
			$map[$i] = $id;
		}
		foreach($children as $cid => $child) {
			if((int)$cid == (int)$id) {
				$this->db->query("UPDATE `".$this->table."` SET `".$this->fields["position"]."` = ".$position." WHERE `".$this->fields["id"]."` = ".$cid);
				continue;
			}
			$this->db->query("UPDATE `".$this->table."` SET `".$this->fields["parent_id"]."` = ".$map[(int)$child[$this->fields["left"]]]." WHERE `".$this->fields["id"]."` = ".$cid);
			for($i = $child[$this->fields["left"]] + 1; $i < $child[$this->fields["right"]]; $i++) {
				$map[$i] = $cid;
			}
		}
	}

	function _reconstruct() {
	
	//$fh = fopen(time()."recontstruct".rand().".txt", 'w') or die("can't open file");
	
		$this->db->query("" . 
			"CREATE TEMPORARY TABLE `temp_tree` (" . 
				"`".$this->fields["id"]."` INTEGER NOT NULL, " . 
				"`".$this->fields["parent_id"]."` INTEGER NOT NULL, " . 
				"`". $this->fields["position"]."` INTEGER NOT NULL" . 
			") type=HEAP"
		);
		$this->db->query("" . 
			"INSERT INTO `temp_tree` " . 
				"SELECT " . 
					"`".$this->fields["id"]."`, " . 
					"`".$this->fields["parent_id"]."`, " . 
					"`".$this->fields["position"]."` " . 
				"FROM `".$this->table."`"
		);

		$this->db->query("" . 
			"CREATE TEMPORARY TABLE `temp_stack` (" . 
				"`".$this->fields["id"]."` INTEGER NOT NULL, " . 
				"`".$this->fields["left"]."` INTEGER, " . 
				"`".$this->fields["right"]."` INTEGER, " . 
				"`".$this->fields["level"]."` INTEGER, " . 
				"`stack_top` INTEGER NOT NULL, " . 
				"`".$this->fields["parent_id"]."` INTEGER, " . 
				"`".$this->fields["position"]."` INTEGER " . 
			") type=HEAP"
		);
		$counter = 2;
		$this->db->query("SELECT COUNT(*) FROM temp_tree");
		$this->db->nextr();
		$maxcounter = (int) $this->db->f(0) * 2;
		$currenttop = 1;
		$this->db->query("" . 
			"INSERT INTO `temp_stack` " . 
				"SELECT " . 
					"`".$this->fields["id"]."`, " . 
					"1, " . 
					"NULL, " . 
					"0, " . 
					"1, " . 
					"`".$this->fields["parent_id"]."`, " . 
					"`".$this->fields["position"]."` " . 
				"FROM `temp_tree` " . 
				"WHERE `".$this->fields["parent_id"]."` = 0"
		);
		$this->db->query("DELETE FROM `temp_tree` WHERE `".$this->fields["parent_id"]."` = 0");

		while ($counter <= $maxcounter) {
			$this->db->query("" . 
				"SELECT " . 
					"`temp_tree`.`".$this->fields["id"]."` AS tempmin, " . 
					"`temp_tree`.`".$this->fields["parent_id"]."` AS pid, " . 
					"`temp_tree`.`".$this->fields["position"]."` AS lid " . 
				"FROM `temp_stack`, `temp_tree` " . 
				"WHERE " . 
					"`temp_stack`.`".$this->fields["id"]."` = `temp_tree`.`".$this->fields["parent_id"]."` AND " . 
					"`temp_stack`.`stack_top` = ".$currenttop." " . 
				"ORDER BY `temp_tree`.`".$this->fields["position"]."` ASC LIMIT 1"
			);

			if ($this->db->nextr()) {
				$tmp = $this->db->f("tempmin");

				$q = "INSERT INTO temp_stack (stack_top, `".$this->fields["id"]."`, `".$this->fields["left"]."`, `".$this->fields["right"]."`, `".$this->fields["level"]."`, `".$this->fields["parent_id"]."`, `".$this->fields["position"]."`) VALUES(".($currenttop + 1).", ".$tmp.", ".$counter.", NULL, ".$currenttop.", ".$this->db->f("pid").", ".$this->db->f("lid").")";
				$this->db->query($q);
				$this->db->query("DELETE FROM `temp_tree` WHERE `".$this->fields["id"]."` = ".$tmp);
				$counter++;
				$currenttop++;
			}
			else {
				$this->db->query("" . 
					"UPDATE temp_stack SET " . 
						"`".$this->fields["right"]."` = ".$counter.", " . 
						"`stack_top` = -`stack_top` " . 
					"WHERE `stack_top` = ".$currenttop
				);
				$counter++;
				$currenttop--;
			}
		}

		$temp_fields = $this->fields;
		unset($temp_fields["parent_id"]);
		unset($temp_fields["position"]);
		unset($temp_fields["left"]);
		unset($temp_fields["right"]);
		unset($temp_fields["level"]);
		if(count($temp_fields) > 1) {
			$this->db->query("" . 
				"CREATE TEMPORARY TABLE `temp_tree2` " . 
					"SELECT `".implode("`, `", $temp_fields)."` FROM `".$this->table."` "
			);
		}
		$this->db->query("TRUNCATE TABLE `".$this->table."`");
		$this->db->query("" . 
			"INSERT INTO ".$this->table." (" . 
					"`".$this->fields["id"]."`, " . 
					"`".$this->fields["parent_id"]."`, " . 
					"`".$this->fields["position"]."`, " . 
					"`".$this->fields["left"]."`, " . 
					"`".$this->fields["right"]."`, " . 
					"`".$this->fields["level"]."` " . 
				") " . 
				"SELECT " . 
					"`".$this->fields["id"]."`, " . 
					"`".$this->fields["parent_id"]."`, " . 
					"`".$this->fields["position"]."`, " . 
					"`".$this->fields["left"]."`, " . 
					"`".$this->fields["right"]."`, " . 
					"`".$this->fields["level"]."` " . 
				"FROM temp_stack " . 
				"ORDER BY `".$this->fields["id"]."`"
		);
		if(count($temp_fields) > 1) {
			$sql = "" . 
				"UPDATE `".$this->table."` v, `temp_tree2` SET v.`".$this->fields["id"]."` = v.`".$this->fields["id"]."` ";
			foreach($temp_fields as $k => $v) {
				if($k == "id") continue;
				$sql .= ", v.`".$v."` = `temp_tree2`.`".$v."` ";
			}
			$sql .= " WHERE v.`".$this->fields["id"]."` = `temp_tree2`.`".$this->fields["id"]."` ";
			$this->db->query($sql);
		}
	}

	function _analyze() {
	
	//$fh = fopen(time()."_analyze".rand().".txt", 'w') or die("can't open file");

	//fclose($fh);
	
		$report = array();

		$this->db->query("" . 
			"SELECT " . 
				"`".$this->fields["left"]."` FROM `".$this->table."` s " . 
			"WHERE " . 
				"`".$this->fields["parent_id"]."` = 0 "
		);
		$this->db->nextr();
		if($this->db->nf() == 0) {
			$report[] = "[FAIL]\tNo root node.";
		}
		else {
			$report[] = ($this->db->nf() > 1) ? "[FAIL]\tMore than one root node." : "[OK]\tJust one root node.";
		}
		$report[] = ($this->db->f(0) != 1) ? "[FAIL]\tRoot node's left index is not 1." : "[OK]\tRoot node's left index is 1.";

		$this->db->query("" . 
			"SELECT " . 
				"COUNT(*) FROM `".$this->table."` s " . 
			"WHERE " . 
				"`".$this->fields["parent_id"]."` != 0 AND " . 
				"(SELECT COUNT(*) FROM `".$this->table."` WHERE `".$this->fields["id"]."` = s.`".$this->fields["parent_id"]."`) = 0 ");
		$this->db->nextr();
		$report[] = ($this->db->f(0) > 0) ? "[FAIL]\tMissing parents." : "[OK]\tNo missing parents.";

		$this->db->query("SELECT MAX(`".$this->fields["right"]."`) FROM `".$this->table."`");
		$this->db->nextr();
		$n = $this->db->f(0);
		$this->db->query("SELECT COUNT(*) FROM `".$this->table."`");
		$this->db->nextr();
		$c = $this->db->f(0);
		$report[] = ($n/2 != $c) ? "[FAIL]\tRight index does not match node count." : "[OK]\tRight index matches count.";

		$this->db->query("" . 
			"SELECT COUNT(`".$this->fields["id"]."`) FROM `".$this->table."` s " . 
			"WHERE " . 
				"(SELECT COUNT(*) FROM `".$this->table."` WHERE " . 
					"`".$this->fields["right"]."` < s.`".$this->fields["right"]."` AND " . 
					"`".$this->fields["left"]."` > s.`".$this->fields["left"]."` AND " . 
					"`".$this->fields["level"]."` = s.`".$this->fields["level"]."` + 1" . 
				") != " .
				"(SELECT COUNT(*) FROM `".$this->table."` WHERE " . 
					"`".$this->fields["parent_id"]."` = s.`".$this->fields["id"]."`" . 
				") "
			);
		$this->db->nextr();
		$report[] = ($this->db->f(0) > 0) ? "[FAIL]\tAdjacency and nested set do not match." : "[OK]\tNS and AJ match";

		return implode("<br />",$report);
	}

	function _dump($output = false) {
	
	//$fh = fopen(time()."dump".rand().".txt", 'w') or die("can't open file");
	
		$nodes = array();
		$this->db->query("SELECT * FROM ".$this->table." ORDER BY `".$this->fields["left"]."`");
		while($this->db->nextr()) $nodes[] = $this->db->get_row("assoc");
		if($output) {
			echo "<pre>";
			foreach($nodes as $node) {
				echo str_repeat("&#160;",(int)$node[$this->fields["level"]] * 2);
				echo $node[$this->fields["id"]]." (".$node[$this->fields["left"]].",".$node[$this->fields["right"]].",".$node[$this->fields["level"]].",".$node[$this->fields["parent_id"]].",".$node[$this->fields["position"]].")<br />";
			}
			echo str_repeat("-",40);
			echo "</pre>";
		}
		return $nodes;
	}
	function _drop() {
	
	//$fh = fopen(time()."drop".rand().".txt", 'w') or die("can't open file");
	
		$this->db->query("TRUNCATE TABLE `".$this->table."`");
		$this->db->query("" . 
				"INSERT INTO `".$this->table."` (" . 
					"`".$this->fields["id"]."`, " . 
					"`".$this->fields["parent_id"]."`, " . 
					"`".$this->fields["position"]."`, " . 
					"`".$this->fields["left"]."`, " . 
					"`".$this->fields["right"]."`, " . 
					"`".$this->fields["level"]."` " . 
					") " . 
				"VALUES (" . 
					"1, " . 
					"0, " . 
					"0, " . 
					"1, " . 
					"2, " . 
					"0 ". 
				")");
	}
}

class json_tree extends _tree_struct { 
	function __construct($table = "tbl_sites_tree", $fields = array(), $add_fields = array("title" => "title", "type" => "type_c"), $sitestable = "tbl_sites") {
	
//	$fh = fopen(time()."treecontstruct".rand().".txt", 'w') or die("can't open file");
//	fwrite($fh, print_r($fields, true));
	

		parent::__construct($table, $fields);
		$this->fields = array_merge($this->fields, $add_fields);
		$this->add_fields = $add_fields;
		
//		fwrite($fh, print_r($fields, true));
//	fclose($fh);
		
	}
																		///CANT FIND CREATE
	function create_node($data) {
	
            
         /*   $myFile = "create_node".rand().".txt";
            $fh = fopen($myFile, 'w') or die("can't open file");
            fwrite($fh, print_r($data, true) );
            fclose($fh);
           */ 
		$sql = "INSERT INTO `".$this->sitestable."` (`name_c`) VALUES ('".$data['title']."');";
		$this->db->query($sql);
		$siteId_n = $this->db->insert_id();
	
		$id = parent::_create($data["id"], (int)$data["position"], $siteId_n);

		if($id) {
			$data["id"] = $id;
			$this->set_data($data);
			return  "[{ \"status\" : 1, \"id\" : \"".(int)$id."-".$siteId_n."\" }]";
		}
		return "{ \"status\" : 0 }";
	}
	
	
	///////This cleans up parents with no children from deletions but havent been updated yet to show, so it displays correctly on the gui
	function fixWidows($siteId_n = -1){

	//	$myFile = "fixWidows".rand().".txt";
	//	$fh = fopen($myFile, 'w') or die("can't open file");
		
		
		//fwrite($fh, print_r($node, true) );
		
				//do a search if no more nodes of this id exist, then delete between left and right
		if ($siteId_n != -1){
		

				//	$myFile = "__fixWidows".rand().".txt";
				//	$fh = fopen($myFile, 'w') or die("can't open file");
				//	fwrite($fh, $siteId_n );
				//	fclose($fh);
		
			$s = "SELECT * from `".$this->table."` where siteId_n =".$siteId_n;
			$this->db->query($s);
			$this->db->nextr();
			if ($this->db->nf() === 0 ) {
				$s = "SELECT * from `".$this->table."` where `".$this->fields["parent_id"]."` =".$siteId_n;
				$this->db->query($s);
				$this->db->nextr();
				if ($this->db->nf() !== 0 ) {
					$node = $this->db->get_row("assoc");
					$s = "Delete from `".$this->table."` where `".$this->fields["parent_id"]."` =".$siteId_n;
					
			//		$myFile = "__fixWidowsDELETE".rand().".txt";
			//		$fh = fopen($myFile, 'w') or die("can't open file");
					
					
					$this->db->query($s);
					
					$s = "Delete from `".$this->sitestable."` where siteId_n = ".$node['siteId_n'];
					$this->db->query($s);
					
			//		fwrite($fh, $s);
			//		fclose($fh);
					
					
					$this->fixWidows($node['siteId_n']);
				}
			}
				
		}
		///clean one way
		$s = "SELECT GROUP_CONCAT(id) AS ids FROM `".$this->table."` WHERE `".$this->table."`.siteId_n NOT IN (SELECT `".$this->fields["parent_id"]."` FROM `".$this->table."`) AND `".$this->fields["right"]."` != `".$this->fields["left"]."` +1";
		$this->db->query($s);
		//fwrite($fh, $s );
		while($this->db->nextr()) $dbids = $this->db->get_row("assoc");
		$s = "UPDATE `".$this->table."` SET `".$this->fields["right"]."` = `".$this->fields["left"]."` +1 WHERE id IN (".$dbids['ids'].")";
		if ( $dbids['ids'] != '' )	$this->db->query($s);
		/// now ensure clean the other way
		$s = "SELECT GROUP_CONCAT(id) AS ids FROM `".$this->table."` WHERE `".$this->table."`.siteId_n IN (SELECT `".$this->fields["parent_id"]."` FROM `".$this->table."`) AND `".$this->fields["right"]."` <= `".$this->fields["left"]."` +1 ";
		$this->db->query($s);
		//fwrite($fh, $s );
		while($this->db->nextr()) $dbids = $this->db->get_row("assoc");
		$s = "UPDATE `".$this->table."` SET `".$this->fields["right"]."` = `".$this->fields["left"]."` +2 WHERE id IN (".$dbids['ids'].")";
		if ( $dbids['ids'] != '')	$this->db->query($s);
		
		
		//fwrite($fh, $s );
		//fclose($fh);
		
	
	}
	
	
	//sets new nodes title and type
	function set_data($data) {
	//$fh = fopen(time()."tree_set_data".rand().".txt", 'w') or die("can't open file");
	
		if(count($this->add_fields) == 0) { return "{ \"status\" : 1 }"; }
		$s = "UPDATE `".$this->table."` SET `".$this->fields["id"]."` = `".$this->fields["id"]."` ";

		foreach($this->add_fields as $k => $v) {
			if ($k != 'title'){
				if(isset($data[$k]))	$s .= ", `".$this->fields[$k]."` = \"".$this->db->escape($data[$k])."\" ";  //i changed this from fields[v] to [k]
				else					$s .= ", `".$this->fields[$v]."` = `".$this->fields[$v]."` ";
			}
		}
		$s .= "                WHERE `".$this->fields["id"]."` = ".$data["id"];
		
		$this->db->query($s);
		return "{ \"status\" : 1 }";
	}
	function rename_node($data) { 
		//return $this->set_data($data); 
		$ids = explode('-', $data["id"]); //id-siteId_n
		$s = "UPDATE `".$this->sitestable."` SET `name_c`='".$data['title']."' WHERE `siteId_n`=".$ids[1];
		$this->db->query($s);
		return "{ \"status\" : 1 }";
	}

	function move_node($data) { 
	
	//	$myFile = "tree_move_noder".rand().".txt";
	//	$fh = fopen($myFile, 'w') or die("can't open file");
	//	fwrite($fh, print_r($data, true));
		
		if ((int)$data["copy"] == 1){
		
			$ids = explode('-', $data["id"]); //id-siteId_n
			$refs = explode('-', $data["ref"]); //siteId_n-groupsites_parent_id
			
		//	$myFile = "tree_move_nodeCOPY".rand().".txt";
		//	$fh1 = fopen($myFile, 'w') or die("can't open file");
			
		
			$s = "UPDATE `".$this->table."` SET `".$this->fields["right"]."`=`".$this->fields["right"]."`+1 WHERE `id`=".$refs[0];
			$this->db->query($s);
		
		//	fwrite($fh1, print_r($data, true) );
		//	fclose($fh);
			
			$s = "SELECT * FROM `".$this->table."` WHERE id = ".$ids[0];
			$this->db->query($s);
			while($this->db->nextr()) $node = $this->db->get_row("assoc");
			//fwrite($fh1, $s.print_r($node, true));
			
			
			$s3 = "Select max(`".$this->fields["position"]."`) as position from `".$this->table."` where `".$this->fields["parent_id"]."` = ".$refs[1];
			$this->db->query($s3);
			$this->db->nextr();
			$row = $this->db->nf() === 0 ? 0 : $this->db->get_row("assoc");
			//while($this->db->nextr()) $row = $this->db->get_row("assoc");
			
			if ($row != 0)
				$position = $row['position'] + 1; 
			else 
				$position = $row['position'];
			
			
			$s2 = "INSERT INTO `".$this->table."` (`".$this->fields["parent_id"]."`, `".$this->fields["position"]."`, `".$this->fields["left"]."`, `".$this->fields["right"]."`, 
				`".$this->fields["level"]."`, `".$this->fields["type"]."`, `siteId_n`) 
				VALUES (".$refs[1].", ".$position.", ".$node['left_n'].", ".$node['right_n'].", "
				.$node['level_n'].", '".$node['type_c']."', ".$ids[1].");";
			//fwrite($fh1, $s2);
			$this->db->query($s2);
			
			
			
			
			return "{ \"status\" : 1 }";
		}
	
	
		$ids = explode('-', $data["id"]); //id-siteId_n
		$refs = explode('-', $data["ref"]); //siteId_n-groupsites_parent_id
		$data["id"] = $ids[1];
		$data["gid"] = $ids[1];
		$data["ref"] = $refs[0];
		
		$data["ref1"] = $refs[1];
		$data["id0"] = $ids[0];

		//fwrite($fh, "--data---".print_r($data, true)  );
		

		$id = parent::_move($data["id"], $refs[1], (int)$data["position"], (int)$data["copy"], $ids[0]);

		if(!$id) return "{ \"status\" : 0 }";
		if((int)$data["copy"] && count($this->add_fields)) {
			$ids	= array_keys($this->_get_children($id, true));
			$data	= $this->_get_children($data["id"], true);

	//	$myFile = "tree_move_node1.txt";
		//$fh = fopen($myFile, 'w') or die("can't open file");
		
			$i = 0;
			foreach($data as $dk => $dv) {
				$s = "UPDATE `".$this->table."` SET `".$this->fields["id"]."` = `".$this->fields["id"]."` "; 
				
				foreach($this->add_fields as $k => $v) {
					if(isset($dv[$k]))	$s .= ", `".$this->fields[$v]."` = \"".$this->db->escape($dv[$k])."\" ";
					else				$s .= ", `".$this->fields[$v]."` = `".$this->fields[$v]."` ";
				}
				$s .= " WHERE `".$this->fields["id"]."` = ".$ids[$i];
				//fwrite($fh, "---------".$s );
				$this->db->query($s);
				$i++;
			}
		}
		
		
		$this->fixWidows();
		
		
		//fclose($fh);
		//return "{ \"status\" : 1, \"id\" : ".$id." }";
		return "{ \"status\" : 1, \"id\" : \"".(int)$id."-".$refs[0]."\" }";
	}
	function remove_node($data) {
		
	$ids = explode('-', $data["id"]); //id-siteId_n
	
		if ( isset ( $data["onlyone"]) ){
			if  ($data["onlyone"] == true){
				$ids = explode('-', $data["id"]); //id-siteId_n
				$id = parent::_remove($ids[1], $ids[0]);
				
				//	$myFile = "removenode1".rand().".txt";
				//	$fh = fopen($myFile, 'w') or die("can't open file");
				//	fwrite($fh, $ids[1]. $ids[0]);
				//	fclose($fh);
			}
		} else{
				$ids = explode('-', $data["id"]); //id-siteId_n
				$s = "SELECT GROUP_CONCAT(id) AS IDS FROM `".$this->table."` WHERE siteId_n = ".$ids[1];
				$this->db->query($s);
				while($this->db->nextr()) $dbids = $this->db->get_row("assoc");
				$idlist = explode("," , $dbids['IDS']);
							
					//	$myFile = "removenode2".rand().".txt";
					//	$fh = fopen($myFile, 'w') or die("can't open file");
					//	fwrite($fh, $dbids['IDS'] );
					//	fclose($fh);

				foreach($idlist as $id){
					parent::_remove($ids[1], $id);
				}
				//$id = parent::_remove($data["id"]);
		}
		
		$this->fixWidows($ids[1]); //siteId_n
		
		return "{ \"status\" : 1 }";
	}
	function get_children($data) {
	
	
//		$myFile = "tree_1getChildren".rand().".txt";
//				$fh = fopen($myFile, 'w');
//	fwrite($fh,$data["id"]);
//		fclose($fh);	
				
	
		$tmp = $this->_get_children($data["id"]);
		
		if($data["id"] === 1 && count($tmp) === 0) {
			$this->_create_default();
			$tmp = $this->_get_children($data["id"]);
			
				//$myFile = "tree_2getChildren".rand().".txt";
				//$fh = fopen($myFile, 'w');
				//fwrite($fh, $tmp);
				//fclose($fh);
				
		}
		$result = array();
		if($data["id"] === 0) return json_encode($result);
		foreach($tmp as $k => $v) {
			$result[] = array(
				"attr" => array("id" => "node_".$k, "rel" => $v[$this->fields["type"]]),
				"data" => $v[$this->fields["title"]],
				"state" => ((int)$v[$this->fields["right"]] - (int)$v[$this->fields["left"]] > 1) ? "closed" : ""
			);
		}
		
		$myresult =$result;
		
//		$myFile = "tree_3getChildren".rand().".txt";
//		$fh = fopen($myFile, 'w');
//		if($myresult) fwrite($fh, print_r($myresult, true));
//		else fwrite($fh, "nothingj");
//		fclose($fh);
				
		
		return json_encode($result);
	}
	function search($data) {
		$this->db->query("SELECT `".$this->fields["left"]."`, `".$this->fields["right"]."`  FROM `".$this->table."` 
		RIGHT JOIN `".$this->sitestable."`  on `".$this->sitestable."` .siteId_n = siteId_n
		WHERE `name_c` LIKE '%".$this->db->escape($data["search_str"])."%'");

		if($this->db->nf() === 0) return "[]";
		$q = "SELECT DISTINCT `".$this->fields["id"]."` FROM `".$this->table."` WHERE 0 ";
		while($this->db->nextr()) {
			$q .= " OR (`".$this->fields["left"]."` < ".(int)$this->db->f(0)." AND `".$this->fields["right"]."` > ".(int)$this->db->f(1).") ";
		}
		$result = array();
		$this->db->query($q);
		while($this->db->nextr()) { $result[] = "#node_".$this->db->f(0); }
		return json_encode($result);
	}

}

?>